/* $Id: AppExecutionBean.java,v 1.7 2005/08/26 04:54:16 ysahara Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow Core.
 * 
 *  Nautica Workflow Core is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow Core is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Nautica Workflow Core Core; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.workflow.dataaccess;

import java.io.Serializable;
import java.sql.Timestamp;

import jp.co.argo21.nautica.workflow.ta.ApplicationState;

/**
 * ̃NX́AAvP[Vse[u(APP_EXECUTION)ɑΉێB
 *
 * @version	$Revision: 1.7 $, $Date: 2005/08/26 04:54:16 $
 * @since	Nautica Workflow 0.9
 */
public class AppExecutionBean implements Serializable
{
	/** VAo[WUID */
	static private final long serialVersionUID = 20050000000000001L;

	/**
	 * AvP[V
	 */
	protected String appName;

	/**
	 * AvP[VNc[G[WFg̃NX
	 */
	protected String toolAgent;

	/**
	 * c[G[WFgssID
	 */
	protected int execId = 0;

	/**
	 * Jn
	 */
	protected Timestamp startDate;

	/**
	 * s
	 */
	protected String starterId;

	/**
	 * I
	 */
	protected Timestamp endDate;

	/**
	 * s
	 */
	protected ApplicationState appState;

	/**
	 * AvP[VsIuWFNg𐶐B
	 */
	public AppExecutionBean()
	{
	    /* Ignore */
	}

	/**
	 * AvP[V擾B
	 *
	 * @return	AvP[V
	 */
	public String getAppName()
	{
		if (appName == null) return "";
		else return appName;
	}
	
	/**
	 * AvP[Vݒ肷B
	 *
	 * @param	appName	AvP[V
	 */
	public void setAppName(String appName)
	{
		this.appName = appName;
	}

	/**
	 * AvP[VNc[G[WFg̃NX擾B
	 *
	 * @return	AvP[VNc[G[WFg̃NX
	 */
	public String getToolAgent()
	{
		if (toolAgent == null) return "";
		else return toolAgent;
	}
	
	/**
	 * AvP[VNc[G[WFg̃NXݒ肷B
	 *
	 * @param	toolAgent	AvP[VNc[G[WFg̃NX
	 */
	public void setToolAgent(String toolAgent)
	{
		this.toolAgent = toolAgent;
	}

	/**
	 * c[G[WFgssID擾B
	 *
	 * @return	c[G[WFgssID
	 */
	public int getExecId()
	{
		return execId;
	}
	
	/**
	 * c[G[WFgssIDݒ肷B
	 *
	 * @param	execId	c[G[WFgssID
	 */
	public void setExecId(int execId)
	{
		this.execId = execId;
	}

	/**
	 * Jn擾B
	 *
	 * @return	Jn
	 */
	public Timestamp getStartDate()
	{
		return startDate;
	}
	
	/**
	 * Jnݒ肷B
	 *
	 * @param	startDate	Jn
	 */
	public void setStartDate(Timestamp startDate)
	{
		this.startDate = startDate;
	}

	/**
	 * s҂擾B
	 *
	 * @return	s
	 */
	public String getStarterId()
	{
		if (starterId == null) return "";
		else return starterId;
	}
	
	/**
	 * s҂ݒ肷B
	 *
	 * @param	starterId	s
	 */
	public void setStarterId(String starterId)
	{
		this.starterId = starterId;
	}

	/**
	 * I擾B
	 *
	 * @return	I
	 */
	public Timestamp getEndDate()
	{
		return endDate;
	}
	
	/**
	 * Iݒ肷B
	 *
	 * @param	endDate	I
	 */
	public void setEndDate(Timestamp endDate)
	{
		this.endDate = endDate;
	}

	/**
	 * sԂ擾B
	 *
	 * @return	s
	 */
	public ApplicationState getAppState()
	{
		return appState;
	}
	
	/**
	 * sԂݒ肷B
	 *
	 * @param	appState	s
	 */
	public void setAppState(ApplicationState appState)
	{
		this.appState = appState;
	}

	/**
	 * K[xWRN^ɂ铖YIuWFNg̉sB
	 *
	 * @throws	Throwable	Cӂ̗O
	 */
	protected void finalize() throws Throwable
	{
		// ɓƎ̉B
		super.finalize();
	}
	
	/**
	 * ̃IuWFNgƂ̔rsAꐫ𔻒肷B
	 *
	 * @param	obj	rIuWFNg
	 * @return	茋
	 */
	public boolean equals(Object obj)
	{
		boolean b = super.equals(obj);
		return b;
	}
}

