/* $Id: ProcessBean.java,v 1.8 2005/08/26 04:54:00 ysahara Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow Core.
 * 
 *  Nautica Workflow Core is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow Core is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Nautica Workflow Core Core; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.workflow.dataaccess;

import java.sql.Timestamp;

import jp.co.argo21.nautica.workflow.wfmc.Process;

/**
 * ̃NX́AvZXCX^Xe[u(PROCESS)ɑΉێB
 *
 * @version	$Revision: 1.8 $, $Date: 2005/08/26 04:54:00 $
 * @since	Nautica Workflow 0.9
 */
public class ProcessBean implements Process
{
	/** VAo[WUID */
	static private final long serialVersionUID = 20050000000000001L;

	/** IDړ */
	static public final String ID_PREFIX  = "PSI";

	/**
	 * vZXCX^XID
	 */
	protected String procID;

	/**
	 * vZXCX^X
	 */
	protected String procName;

	/**
	 * pbP[WID
	 */
	protected String packageID;

	/**
	 * vZX`ID
	 */
	protected String procDefID;

	/**
	 * Jn
	 */
	protected Timestamp startDate;

	/**
	 * Jn
	 */
	protected String starterID;

	/**
	 * s
	 */
	protected Timestamp durationLimit;

	/**
	 * 
	 */
	protected int procState;

	/**
	 * ŐVԍXV
	 */
	protected Timestamp updateDate;

	/**
	 * vZXCX^XIuWFNg𐶐B
	 */
	public ProcessBean()
	{
	}

	/**
	 * vZXCX^XID擾B
	 *
	 * @return	vZXCX^XID
	 */
	public String getID()
	{
		if (procID == null) return "";
		else return procID;
	}
	
	/**
	 * vZXCX^XIDݒ肷B
	 *
	 * @param	procID	vZXCX^XID
	 */
	public void setID(String procID)
	{
		this.procID = procID;
	}

	/**
	 * vZXCX^X擾B
	 *
	 * @return	vZXCX^X
	 */
	public String getName()
	{
		if (procName == null) return "";
		else return procName;
	}
	
	/**
	 * vZXCX^Xݒ肷B
	 *
	 * @param	procName	vZXCX^X
	 */
	public void setName(String procName)
	{
		this.procName = procName;
	}

	/**
	 * pbP[WID擾B
	 *
	 * @return	pbP[WID
	 */
	public String getPackageID()
	{
		if (packageID == null) return "";
		else return packageID;
	}
	
	/**
	 * pbP[WIDݒ肷B
	 *
	 * @param	packageID	pbP[WID
	 */
	public void setPackageID(String packageID)
	{
		this.packageID = packageID;
	}

	/**
	 * vZX`ID擾B
	 *
	 * @return	vZX`ID
	 */
	public String getProcDefinitionID()
	{
		if (procDefID == null) return "";
		else return procDefID;
	}
	
	/**
	 * vZX`IDݒ肷B
	 *
	 * @param	procDefID	vZX`ID
	 */
	public void setProcDefinitionID(String procDefID)
	{
		this.procDefID = procDefID;
	}

	/**
	 * Jn擾B
	 *
	 * @return	Jn
	 */
	public Timestamp getStartDate()
	{
		return startDate;
	}
	
	/**
	 * Jnݒ肷B
	 *
	 * @param	startDate	Jn
	 */
	public void setStartDate(Timestamp startDate)
	{
		this.startDate = startDate;
	}

	/**
	 * Jn҂擾B
	 *
	 * @return	Jn
	 */
	public String getStarterID()
	{
		if (starterID == null) return "";
		else return starterID;
	}
	
	/**
	 * Jn҂ݒ肷B
	 *
	 * @param	starterID	Jn
	 */
	public void setStarterID(String starterID)
	{
		this.starterID = starterID;
	}

	/**
	 * s擾B
	 *
	 * @return	s
	 */
	public Timestamp getDurationLimit()
	{
		return durationLimit;
	}
	
	/**
	 * sݒ肷B
	 *
	 * @param	durationLimit	s
	 */
	public void setDurationLimit(Timestamp durationLimit)
	{
		this.durationLimit = durationLimit;
	}

	/**
	 * Ԃ擾B
	 *
	 * @return	
	 */
	public int getProcessState()
	{
		return procState;
	}
	
	/**
	 * Ԃݒ肷B
	 *
	 * @param	procState	
	 */
	public void setProcessState(int procState)
	{
		this.procState = procState;
	}

	/**
	 * ŐVԍXV擾B
	 *
	 * @return	ŐVԍXV
	 */
	public Timestamp getUpdateDate()
	{
		return updateDate;
	}
	
	/**
	 * ŐVԍXVݒ肷B
	 *
	 * @param	updateDate	ŐVԍXV
	 */
	public void setUpdateDate(Timestamp updateDate)
	{
		this.updateDate = updateDate;
	}

	/**
	 * K[xWRN^ɂ铖YIuWFNg̉sB
	 *
	 * @throws	Throwable	Cӂ̗O
	 */
	protected void finalize() throws Throwable
	{
		// ɓƎ̉B
		super.finalize();
	}
	
	/**
	 * ̃IuWFNgƂ̔rsAꐫ𔻒肷B
	 *
	 * @param	obj	rIuWFNg
	 * @return	茋
	 */
	public boolean equals(Object obj)
	{
		boolean b = super.equals(obj);
		return b;
	}
}