/* $Id: ParticipantImpl.java,v 1.8 2005/08/26 04:53:13 ysahara Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow Core.
 * 
 *  Nautica Workflow Core is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation; either version 2.1 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow Core is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 * 
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with Nautica Workflow Core Core; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.workflow.engine;

import jp.co.argo21.nautica.workflow.omg.NotAssignedException;
import jp.co.argo21.nautica.workflow.omg.WfAssignment;
import jp.co.argo21.nautica.workflow.omg.WorkflowException;
import jp.co.argo21.nautica.workflow.wfmc.Participant;

/**
 * [Nt[Q҂̎NXłB
 *
 * @author  nito(Argo 21, Corp.)
 * @version $Revision: 1.8 $
 * @since   Nautica Workflow 0.9
 */
public class ParticipantImpl implements Participant
{
	/** VAo[WUID */
	static private final long serialVersionUID = 20050000000000001L;

	/** VXeID */
	public static final String SYSTEM_ID   = "__SYSTEM__";
	/** VXe[U */
	public static final String SYSTEM_NAME = "NAUTICA SYSTEM";

	/** VXeQ */
	private static final Participant SYSTEM_PARTICIPANT
		= new ParticipantImpl(SYSTEM_ID, SYSTEM_NAME, Participant.SYSTEM);
	
	/** QID */
	private String id;
	/** QҖ */
	private String name;
	/** QҌ^ */
	private int type;
	
	/**
	 * VXeQ҂擾B
	 *
	 * @return VXeQ
	 */
	static public Participant getSystemParticipant()
	{
		return SYSTEM_PARTICIPANT;
	}

	/**
	 * [Nt[Q҂𐶐B
	 */
	public ParticipantImpl(String id, String name, int type)
	{
		this.id = id;
		this.name = name;
		this.type = type;
	}

	/**
	 * IDԂB
	 *
	 * @return ID
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public String getID() throws WorkflowException
	{
		return id;
	}

	/**
	 * ̂Ԃ
	 *
	 * @return 
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public String getName() throws WorkflowException
	{
		return name;
	}

	/**
	 * QҌ^ԂB
	 * 
	 * @return	QҌ^
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public int getType() throws WorkflowException
	{
		return type;
	}

	/**
	 * ێ鑮ԂB
	 *
	 * @param name 
	 * @return l
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public String getAttribute(String name)
	throws WorkflowException
	{
		return null;
	}

	/**
	 * ݒ肷B
	 *
	 * @param name 
	 * @param value l
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public void setAttribute(String name, String value)
	throws WorkflowException
	{
	}

	/**
	 * ێ邷ׂĂ̑ԂB
	 *
	 * @return ̈ꗗ
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public String[] getAllAttributeNames()
	throws WorkflowException
	{
		return null;
	}

	/**
	 * \[XɊ֘AtꂽATCǧԂB
	 *
	 * @return 
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public int getWorkItemCount() throws WorkflowException
	{
		return 0;
	}

	/**
	 * CfNXŎw肳ꂽATCgԂB
	 *
	 * @param index CfNX
	 * @return ATCg
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public WfAssignment getWorkItem(int index) throws WorkflowException
	{
		return null;
	}

	/**
	 * \[XɊ֘AtꂽׂẴATCgԂB
	 *
	 * @return ATCg̈ꗗ
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public WfAssignment[] getAllWorkItem() throws WorkflowException
	{
		return null;
	}

	/**
	 * Ŏw肳ꂽATCgƁA֘AǂԂB
	 *
	 * @param ass ATCg
	 * @return ֘Aꍇtrue
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public boolean isMemberOfWorkItems(WfAssignment ass)
	throws WorkflowException
	{
		return false;
	}

	/**
	 * Ɏw肵ATCgɂƂāA
	 * \[XsvɂȂƂʒm郊Xi[C^tF[XB
	 * ƂāA\[XɊ֘AtĂȂATCgƁA
	 * \[X闝RƂB
	 * ̃C^tF[X́AATCg폜ꂽꍇA
	 * ATCg̃\[X֍Ċ蓖Ăꂽꍇ
	 * IɌĂяo邱Ƃz肵ĂB
	 *
	 * @param ass ATCg
	 * @param info J闝R
	 * @throws NotAssignedException ATCg֘AĂȂꍇ
	 * @throws WorkflowException@[Nt[֘AŗOꍇ
	 */
	public void release(WfAssignment ass, String info)
	throws NotAssignedException, WorkflowException
	{
	}
}
