/* $Id: ConditionalExpression.java,v 1.3 2005/08/26 04:51:16 ysahara Exp $
 * 
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow.
 * 
 *  Nautica Workflow is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Nautica Workflow; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.tool.wfd.expression;

import java.util.List;

import org.apache.xmlbeans.XmlObject;

import jp.co.argo21.nautica.workflow.xpdl.ConditionalExpressionDocument;
import jp.co.argo21.nautica.workflow.xpdl.LogicalExpressionDocument;
import jp.co.argo21.nautica.workflow.xpdl.RelationalExpressionDocument;
import jp.co.argo21.nautica.workflow.xpdl.UnaryExpressionDocument;

/**
 * Jڏ
 * 
 * @author  Norihiro Itoh(ARGO 21 Corp.)
 * @version $Revision: 1.3 $
 * @since   Nautica Workflow 0.9
 */
public class ConditionalExpression implements Expression
{
	/** ʂ̏ */
	private Expression subExpression;
	
	/**
	 * Jڏ
	 * 
	 * @param exp	
	 */
	public ConditionalExpression(Expression exp)
	{
		subExpression = exp;
	}

	/**
	 * XMLJڏ𐶐B
	 * 
	 * @param exp	XML
	 */
	public ConditionalExpression(ConditionalExpressionDocument.ConditionalExpression exp)
	{
		if (exp.isSetUnaryExpression()) {
			UnaryExpressionDocument.UnaryExpression unary = exp.getUnaryExpression();
			subExpression = new UnaryExpression(unary);
		} else if (exp.isSetLogicalExpression()) {
			LogicalExpressionDocument.LogicalExpression logic = exp.getLogicalExpression();
			subExpression = new LogicalExpression(logic);
		} else if (exp.isSetRelationalExpression()) {
			RelationalExpressionDocument.RelationalExpression rel = exp.getRelationalExpression();
			subExpression = new RelationalExpression(rel);
		}
	}
	
	/**
	 * ̃IuWFNgɏi[B
	 * 
	 * @param o	XMLIuWFNg
	 * @see jp.co.argo21.nautica.tool.wfd.expression.Expression#saveTo(org.apache.xmlbeans.XmlObject)
	 */
	public void saveTo(XmlObject o)
	{
		if (o == null) return;
		if (subExpression == null) return;
		if (!(o instanceof ConditionalExpressionDocument.ConditionalExpression)) return;

		ConditionalExpressionDocument.ConditionalExpression ce
			= (ConditionalExpressionDocument.ConditionalExpression)o;

		XmlObject exp = null;
		if (subExpression instanceof UnaryExpression) {
			exp = ce.addNewUnaryExpression();
		} else if (subExpression instanceof LogicalExpression) {
			exp = ce.addNewLogicalExpression();
		} else if (subExpression instanceof RelationalExpression) {
			exp = ce.addNewRelationalExpression();
		}
		subExpression.saveTo(exp);
	}

	/**
	 * ̏ɏ]B
	 * 
	 * @param list	ϐ̌ݒl
	 * @return	ꂽꍇtrue
	 * @see jp.co.argo21.nautica.tool.wfd.expression.Expression#eval(java.util.List)
	 */
	public boolean eval(List list)
	{
		if (subExpression == null) return true;
		else return subExpression.eval(list);
	}

	/**
	 * ̕\ԂB
	 * 
	 * @return	\
	 * @see jp.co.argo21.nautica.tool.wfd.expression.Expression#getExpressionString()
	 */
	public String getExpressionString()
	{
		String s = "null";
		if (subExpression != null) s = subExpression.getExpressionString();

		return "(" + s + ")";
	}

	/**
	 * ϐꗗ𗘗pȂ̕\ԂB
	 * 
	 * @param vars	ϐꗗ
	 * @return	\
	 * @see jp.co.argo21.nautica.tool.wfd.expression.Expression#getExpressionString(java.util.List)
	 */
	public String getExpressionString(List vars)
	{
		String s = "null";
		if (subExpression != null) s = subExpression.getExpressionString(vars);

		return "(" + s + ")";
	}

	/**
	 * ̏Ɋ܂܂邷ׂĂ̏ԂB
	 * 
	 * @param exps	ꗗ
	 * @see jp.co.argo21.nautica.tool.wfd.expression.Expression#getAllExpressions(java.util.List)
	 */
	public void getAllExpressions(List exps)
	{
		if (subExpression != null) subExpression.getAllExpressions(exps);
	}
}
