/* $Id: SimulatorDialog.java,v 1.3 2005/08/26 04:50:02 ysahara Exp $
 * 
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow.
 * 
 *  Nautica Workflow is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Nautica Workflow; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.tool.wfd.sim;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import jp.co.argo21.commons.util.ResourceManager;
import jp.co.argo21.nautica.tool.wfd.WorkflowDesignerManager;
import jp.co.argo21.nautica.tool.wfd.element.ActivityElement;

/**
 * V~[Vp̃_CAO񋟂B
 * 
 * @author  Norihiro Itoh(ARGO 21 Corp.)
 * @version $Revision: 1.3 $
 * @since   Nautica Workflow 0.9
 */
public class SimulatorDialog extends JDialog
{
	/** ݒ */
	static public final int EVAL_END_OPTION = 0;
	/** ] */
	static public final int EVAL_OPTION = 1;
	/**  */
	static public final int END_OPTION  = 2;

	/** r[e */
	private SimulatorView view;
	/** I */
	private int result = EVAL_END_OPTION;

	/**
	 * ϐҏWp̃_CAO𐶐B
	 */
	SimulatorDialog()
	{
		super((Frame)null, true);
		
		ResourceManager rm = WorkflowDesignerManager.getResourceManager();

		setTitle(rm.getResource("SimulatorDialog.title"));
		
		view = new SimulatorView();

		JScrollPane scroll = new JScrollPane();
		scroll.setViewportView(view);

		JPanel buttonPane = new JPanel();
		buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT, 10, 10));

		ActionListener listener = new CloseAction();
		JButton evalButton = new JButton(rm.getResource("JButton.label.evaluate"));
		evalButton.setActionCommand("EVALUATE_OPTION");
		evalButton.addActionListener(listener);
		getRootPane().setDefaultButton(evalButton);
		buttonPane.add(evalButton);

		JButton endButton = new JButton(rm.getResource("JButton.label.end"));
		endButton.addActionListener(listener);
		buttonPane.add(endButton);

		Container contentPane = getContentPane();
		contentPane.add(scroll, BorderLayout.CENTER);
		contentPane.add(buttonPane, BorderLayout.PAGE_END);

		pack();

		setLocationRelativeTo(null);
	}

	/**
	 * _CAOB
	 */
	private void init()
	{
		result = EVAL_END_OPTION;
		view.init();
	}

	/**
	 * OǂԂB
	 * 
	 * @return	OIȂtrue
	 */	
	boolean isExceptionRaising()
	{
		return view.isExceptionRaising();
	}

	/**
	 * ϐꗗԂB
	 * 
	 * @return	ϐꗗ
	 */	
	List getCurrentVariables()
	{
		return view.getCurrentVariables();
	}
	
	/**
	 * ϐꗗݒ肷B
	 * 
	 * @param vars	ϐꗗ
	 */
	void setCurrentVariables(List vars)
	{
		init();
		view.setCurrentVariables(vars);
	}
	
	/**
	 * ANeBreBݒ肷B
	 * 
	 * @param act	ANeBreB
	 */
	void setCurrentActivity(ActivityElement act)
	{
		init();
		view.setCurrentActivity(act);
	}

	/**
	 * lҏW̉ۂݒ肷B
	 * 
	 * @param b	ҏW
	 */	
	void setValueEditable(boolean b)
	{
		view.setValueEditable(b);
	}
	
	/**
	 * _CAOƂ̌ʂԂB
	 * 
	 * @return	
	 */
	int getResult()
	{
		return result;
	}

	/**
	 * _CAOƂ̏
	 */
	private class CloseAction implements ActionListener
	{
		/**
		 * ꂽ{^ɉČʂ؂ւB
		 * 
		 * @param e	Cxg
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e)
		{
			if ("EVALUATE_OPTION".equals(e.getActionCommand())) {
				result = EVAL_OPTION;
			} else {
				result = END_OPTION;
			}
			setVisible(false);
		}
	}
}
