/* $Id: ChangeActivityStateServlet.java,v 1.5 2005/08/26 04:48:32 ysahara Exp $
 *
 * Copyright (c)ARGO 21, Corporation. 2005.  All rights reserved.
 * 
 * This file is part of Nautica Workflow.
 * 
 *  Nautica Workflow is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 * 
 *  Nautica Workflow is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with Nautica Workflow; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *  
 */
package jp.co.argo21.nautica.workflow.servlet;

import java.io.IOException;
import java.rmi.RemoteException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import jp.co.argo21.nautica.workflow.rmi.WorkflowEngineHandlerRemote;
import jp.co.argo21.nautica.workflow.util.StringManager;
import jp.co.argo21.nautica.workflow.wfmc.ActivityState;
import jp.co.argo21.nautica.workflow.wfmc.InvalidSessionException;

import org.apache.log4j.Logger;

/**
 * ANeBreBCX^XԂ̕ύXsT[ubgłB
 *
 * @author  ysahara(Argo 21, Corp.)
 * @version $Revision: 1.5 $
 * @since   Nautica Workflow 0.9
 */
public class ChangeActivityStateServlet extends HttpServlet {

	/** Oo͗pIuWFNg */
	private static Logger log = Logger.getLogger(
			ChangeActivityStateServlet.class);
	
	/**
	 * GET vB<br>
	 * SĂ̏ doPost ɈϏB
	 * 
	 * @param req HttpServletRequest IuWFNg
	 * @param res HttpServletResponse IuWFNg
	 * @throws ServletException vłȂꍇ
	 * @throws IOException o̓G[oꂽꍇ
	 * @see javax.servlet.http.HttpServlet#doGet(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse res)
		throws ServletException,IOException {
		this.doPost(req, res);
	}

	/**
	 * POST vB<br>
	 * [Nt[GWɐڑėvɊւ鏈sB
	 *
	 * @param req HttpServletRequest IuWFNg
	 * @param res HttpServletResponse IuWFNg
	 * @throws ServletException vłȂꍇ
	 * @throws IOException o̓G[oꂽꍇ
	 * @see javax.servlet.http.HttpServlet#doPost(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse res)
		throws ServletException,IOException {
		
		// HttpServletRequest GWJC^tF[Ẍ擾
		String session = NWFRequestUtil.getSession(req);
		String pid = NWFRequestUtil.getProcessInstanceID(req);
		String aid = NWFRequestUtil.getActivityInstanceID(req);
		ActivityState state = NWFRequestUtil.getActivityState(req);
		
		// Oo
		String I4001 = StringManager.get("I4001")
			+ "(SessionID=" + session 
			+ ", ProcessInstanceID=" + pid 
			+ ", ActivityInstanceID=" + aid 
			+ ", ActivityInstanceState=" + state + ")";
		log.info(I4001);

		// GWƂ̃[gʐM
		try {
			WorkflowEngineHandlerRemote weh 
				= WorkflowRemoteServiceAccessor.
					getWorkflowEngineHandlerRemote(session);
			weh.changeActivityState(session, pid, aid, state);
			
		} catch (RemoteException ex) {
			String errMsg = StringManager.get("E4004");
			log.error(errMsg);
			throw new ServletException(errMsg);
		
		} catch (InvalidSessionException ex) {
			// WorkflowRemoteServiceAccessor NXŃOo͍ς
			throw new ServletException(ex);
		
		} catch (Exception ex) {
			String errMsg = StringManager.get("E4006");
			log.error(errMsg);
			throw new ServletException(errMsg, ex);
		}
		
		// Oo
		String I4002 = StringManager.get("I4002"); 
		log.info(I4002);
	}
}
